Unit MLML21_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure MLML21(var XK :Array of Real; var X :Array of Real;
                var L :Integer; var NB :Array of Integer;
                var ALFA :Array of Real; KV :Integer; E1 :Real;
                PR6 :Integer; M :Integer; var TETA :Real;
                var PR17 :Real; var PR16 :Integer; P :Integer;
                var DUR4 :Real; var DUR5 :Real;
                var NALFA :Array of Integer);

implementation

procedure MLML21(var XK :Array of Real; var X :Array of Real;
                var L :Integer; var NB :Array of Integer;
                var ALFA :Array of Real; KV :Integer; E1 :Real;
                PR6 :Integer; M :Integer; var TETA :Real;
                var PR17 :Real; var PR16 :Integer; P :Integer;
                var DUR4 :Real; var DUR5 :Real;
                var NALFA :Array of Integer);
var
PR12,R10,R7,R4 :Integer;
R1,R9 :Real;
const
SYS085 :Real = 1.0E-9;
OE18 :Real = 1.0E10;
label
_5,_2,_1,_7,_6,_3,_10,_11,_4;
begin

{      OCK CTOA,BBOMOO  ACA. }
{      L-HOMEP BBOMOO CTOA. }

PR17 := OE18;
R10 := M-2;
if ( PR6 = 0 )
 then goto _2;
for PR12:=1 to R10 do
 begin
_5:
  XK[PR12-1] := -XK[PR12-1];
 end;
_2:
PR12 := 0;
_1:
PR12 := PR12+1;
if ( XK[PR12-1] <= E1 )
 then goto _3;
R1 := X[PR12-1]/XK[PR12-1];
if ( R1 > TETA )
 then goto _6;
if ( Abs(R1-TETA) <= SYS085 )
 then goto _6;
DUR5 := X[PR12-1];
_7:
L := PR12;
TETA := R1;
DUR4 := XK[PR12-1];
_6:
if ( PR12 <> R10 )
 then goto _1;
goto _4;
_3:
if ( Abs(E1) >= Abs(XK[PR12-1]) )
 then goto _6;
if ( NB[PR12-1] = 0 )
 then goto _6;
for R7:=1 to KV do
 begin
  R4 := NALFA[R7-1];
  if ( R4 = NB[PR12-1] )
   then goto _11;
_10:
 end;
goto _6;
_11:
R9 := X[PR12-1]-ALFA[R7-1];
R1 := R9/XK[PR12-1];
if ( R1 >= TETA )
 then goto _6;
PR17 := R1;
PR16 := R7;
DUR5 := R9;
goto _7;
_4:
end;

end.
