Unit MLOGR_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, MLMPM_p, MLMU_p, MLMD_p, MLMVK1_p, MLMXK2_p, MLML11_p, 
MLML21_p, MLMG11_p, MLMX1_p, MLMUZ2_p, MLMPK_p, MLMRN_p, MLMVX1_p, 
MLMLZ_p, MLMXI_p, MLMBR_p;

procedure MLOGR(M :Integer; N :Integer; PRP :Integer;
                var A :Array of Real; var NSA :Array of Integer;
                var NTAB :Array of Integer; var ALFA :Array of Real;
                var NALFA :Array of Integer; var KV :Integer;
                var B :Array of Real; var C :Array of Real;
                LB :Integer; var EPS :Real; MNMX :Integer;
                var F :Real; var IM :Array of Integer;
                var RM :Array of Real; var IERR :Integer);

implementation

procedure MLOGR(M :Integer; N :Integer; PRP :Integer;
                var A :Array of Real; var NSA :Array of Integer;
                var NTAB :Array of Integer; var ALFA :Array of Real;
                var NALFA :Array of Integer; var KV :Integer;
                var B :Array of Real; var C :Array of Real;
                LB :Integer; var EPS :Real; MNMX :Integer;
                var F :Real; var IM :Array of Integer;
                var RM :Array of Real; var IERR :Integer);
var
IM1,IM2,IM3,IM4,IM5,IM6,IM7,IM8,IM9,ZB,S,ZM,K1,K,R,R2,R3,R4,R10,R11,I,
   L,PR,PR6,PR12,PR16,K2,KZ,R1 :Integer;
DUR5,TETA,PR13,PR17,G,DUR4 :Real;
const
E1 :Real = 0.244E-6;
OTE18 :Real = 1.0E10;
label
_20,_10,_30,_40,_50,_60,_70,_90,_95,_100,_110,_120,_140,_150,_160,
_170,_180,_200,_190;
begin

{      POPAMMA PEEH AA HEHOO POPAMMPOBAH C BX- }
{      CTOPOHHM OPAHEHM HA EPEMEHHE C MTKATBHM }
{      PECTABEHEM OPATHO MATP  EPECETAM }
{            APAMETP: }
{      M    -CO CTPOK B PACPEHHO MATPE COB }
{      N    -CO CTOOB B MATPE COB }
{      PRP  -CO TEPA,OCE KOTOPOO EAETC EPECET OPATHO }
{           -MATP,PTEHO PABHO 3*M/2 }
{      A    -BEECTBEHH MACCB, COEPA HEHEBE EMEHT }
{           -MATP COB O CTOAM }
{      NSA  -HOMEPA CTPOK HEHEBX EMEHTOB }
{      NTAB -TAA HEHEBX EMEHTOB O CTOAM }
{      ALFA -BEKTOP BEPXHX OPAHEH }
{      NALFA-HOMEPA BEPXHX OPAHEH }
{      KV   -KOECTBO BEPXHX OPAHEH }
{      B    -BEKTOP OPAHEH }
{      C    -KOEHT HEHO OPM }
{      LB   -HA MACCBA  AC MTKATOPOB  PABHA PRP*M }
{      EPS  -APAMETP TOHOCT }
{      MNMX -PHAK BBOA:MNMX=1,KOA AAA OCTABEHA HA MAKCMM, }
{            MNMX=0,KOA AAA OCTABEHA HA MHMM }
{      F    -OTMAHOE HAEHE HEHO OPM }
{      IM   -E PAO MACCB (INTEGER*2) H (1+6*M+2*N+LB) }
{      RM   -BEECTBEHH PAO MACCB DH (1+4*M+N+LB) }
{            OCE OKOHAH CETA B EPBX N EKAX CTOT PEEHE }
{      IERR -PHAK OKOHAH: }
{            =0-OEHO OTMAHOE PEEHE }
{            =65-AAA HECOBMECTHA }
{            =66-HEHA OPMA HEOPAHEHA }
S := 0;
ZM := 1;
K1 := 0;
ZB := 0;
K2 := 1;
EPS := -EPS;
IM1 := M+1;
IM2 := 2*M+1;
IM3 := 2*M+1+N;
IM4 := 2*M+2*N+1;
IM5 := 3*M+1;
IM6 := 4*M+1;
IM7 := 4*M+1+N;
IM8 := 4*M+2*N+1;
IM9 := 6*M+2*N+1;
for I:=1 to N do
 begin
_20:
  IM[IM2+I-2] := 0;
 end;
MLMPM(A,NSA,NTAB,C,IM[IM2-1],B,RM[IM6-1],IM,M,N,MNMX,ZM);
for I:=1 to M do
 begin
_10:
  RM[IM1+I-2] := B[I-1];
 end;
for I:=1 to KV do
 begin
_30:
  IM[IM3+I-2] := 0;
 end;
_40:
MLMU(RM[IM7-1],S,IM[IM4-1],IM[IM8-1],K1,M,RM[IM2-1],RM[IM5-1],
IM[IM9-1],ZM,ZB);
{ - - - - - - - }
{      BCEHE OEHOK  BHEACHX BEKTOPOB }
{      K-HOMEP CTOA,BBOMOO B AC }

MLMD  (RM[IM2-1],A,C,M,N,EPS,K,ALFA,KV,RM[IM5-1],RM[IM6-1],G,
IM[IM2-1],IM[IM3-1],NSA,NTAB,NALFA,ZB);
if ( G = EPS )
 then goto _95;
_50:
MLMVK1(A,C,K,M,RM,RM[IM6-1],N,NTAB,NSA);
MLMXK2(RM,RM[IM7-1],IM[IM4-1],IM[IM8-1],K1,IM[IM9-1]);
if ( K2 = 0 )
 then goto _170;
IM[IM2+K-2] := 1;
{ __________ }
{      OPEEEHE HOMEPA L BBOMOO  ACA CTOA }

MLML11(K,ALFA,KV,PR6,TETA,PR13,PR,IM[IM3-1],NALFA);
MLML21(RM,B,L,IM,ALFA,KV,E1,PR6,M,TETA,PR17,PR16,
MNMX,DUR4,DUR5,NALFA);
if ( TETA <> OTE18 )
 then goto _60;
IERR := 66;
goto _190;
_60:
if ( PR13 = 0.0 )
 then goto _70;
if ( TETA <> PR13 )
 then goto _70;
MLMG11(B,RM,IM[IM2-1],IM[IM3-1],PR13,PR6,K,PR,M);
goto _40;
{ - - - - - - }
{      EPECET KOMOHEHT ACHOO PEEH }

_70:
MLMX1(TETA,PR17,PR16,PR6,PR,M,RM,L,B,RM[IM5-1],PR13,
IM,K,DUR4,DUR5,IM[IM3-1],IM[IM2-1]);
K1 := K1+1;
if ( (S+M) >= LB )
 then goto _140;
if ( K1 = PRP )
 then goto _140;
{ - - - - - - - }
{      AC OEPEHOO MTKATOPA }

MLMUZ2(RM[IM7-1],S,L,M,IM[IM4-1],IM[IM8-1],RM[IM5-1],K1,IM[IM9-1]);
_90:
MLMPK(IM,ZM,M);
goto _40;
{ - - - - - - - }
{      POBEPET KOHE EPBOO TAA ,EC B ACE HE OCTAOC }
{      CKCCTBEHHX EPEMEHHX,TO AHOCTC PHAK ZM=0  EPEXO }
{      KO BTOPOM TA }

_95:
if ( ZM = 0 )
 then goto _100;
if ( B[M-1] < EPS )
 then goto _100;
ZM := 0;
ZB := 1;
goto _40;
_100:
if ( MNMX <> 0 )
 then goto _110;
B[M-2] := -B[M-2];
_110:
if ( ZM = 0 )
 then goto _120;
IERR := 65;
goto _190;
_120:
IERR := 0;
goto _190;
{ - - - - - - - }
{      EPECET MTKATOPOB OPATHO MATP }

_140:
K1 := 0;
R1 := 0;
K2 := 0;
S := 0;
{ - - - - - - - }
{      OPOEHE HOMEPOB ACHX KOMOHEHT }

MLMRN(IM,M,NTAB);
for I:=1 to M do
 begin
  IM[IM1+I-2] := IM[I-1];
  B[I-1] := RM[IM1+I-2];
_150:
  IM[I-1] := 0;
 end;
MLMVX1(ALFA,KV,B,M,A,C,RM[IM6-1],IM[IM2-1],IM[IM3-1],
NALFA,NSA,NTAB);
_160:
R1 := R1+1;
if ( IM[IM1+R1-2] = 0 )
 then goto _180;
K := IM[IM1+R1-2];
goto _50;
_170:
MLMLZ(RM,L,IM,IM[IM1-1],M);
if ( Abs(RM[L-1]) < Abs(E1) ) 
 then goto _200;
MLMXI(RM,L,RM[IM5-1],B,M);
IM[L-1] := K;
K1 := K1+1;
MLMUZ2(RM[IM7-1],S,L,M,IM[IM4-1],IM[IM8-1],RM[IM5-1],K1,IM[IM9-1]);
_180:
if ( R1 <> M-2 )
 then goto _160;
_200:
K2 := 1;
goto _90;
_190:
F := B[M-2];
MLMBR(IM,RM     ,B,ALFA,NALFA,IM[IM3-1],M,KV,N);
end;

end.
